-------------------------------------------------------------------------------
-- (C) Altran Praxis Limited
-------------------------------------------------------------------------------
--
-- The SPARK toolset is free software; you can redistribute it and/or modify it
-- under terms of the GNU General Public License as published by the Free
-- Software Foundation; either version 3, or (at your option) any later
-- version. The SPARK toolset is distributed in the hope that it will be
-- useful, but WITHOUT ANY WARRANTY; without even the implied warranty of
-- MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General
-- Public License for more details. You should have received a copy of the GNU
-- General Public License distributed with the SPARK toolset; see file
-- COPYING3. If not, go to http://www.gnu.org/licenses for a complete copy of
-- the license.
--
--=============================================================================
with SPARK.Ada.Text_IO;

package body Fatal is

   procedure Stop_With_Command_Line_Exception
   is
   --# hide Stop_With_Command_Line_Exception;
   begin
      SPARK.Ada.Text_IO.Put_Line_Error ("Usage: sparklalr [-v] [-s] [-m] [-d[a-i|u]] [-p] <grammar_file_name>");
      SPARK.Ada.Text_IO.Put_Line_Error ("");
      SPARK.Ada.Text_IO.Put_Line_Error ("Options: -v verbose output");
      SPARK.Ada.Text_IO.Put_Line_Error ("         -s self pack");
      SPARK.Ada.Text_IO.Put_Line_Error ("         -m multi comp");
      SPARK.Ada.Text_IO.Put_Line_Error ("         -d[a-i] debug [level]");
      SPARK.Ada.Text_IO.Put_Line_Error ("         -du debug dump memory");
      SPARK.Ada.Text_IO.Put_Line_Error ("         -p parser");
      raise Command_Line_Error;
   end Stop_With_Command_Line_Exception;

end Fatal;
